{% macro header_start(additional_vars) -%}
{{ ('{:' + (([additional_vars["longest_key"], 15]|max)|string) + 's}').format(_('Source')) }}  {{ '{:16s}'.format(_('First event')) }}  {{ '{:16s}'.format(_('Last event')) }}  {{ '{:>6s}'.format(_('Detect')) }}  {{ '{:>5s}'.format(_('Msgs')) }}
{%- endmacro %}

{% macro header(additional_vars) -%}
{{ header_start(additional_vars) }}  {{ _('Protocol') }}
{%- endmacro %}

{% macro row_start(key, data, additional_vars) -%}
{% set report_datetime_format = 'dd.MM. HH:mm:ss' -%}
{{ ('{:' + (([additional_vars["longest_key"], 15]|max)|string) + 's}').format(key) }}  {{ '{:<16s}'.format(format_custom_datetime(data['first_time'], report_datetime_format)) }}  {{ '{:<16s}'.format(format_custom_datetime(data['last_time'], report_datetime_format)) }}  {{ '{:>6s}'.format(format_decimal(data['detectors_count'])) }}  {{ '{:>5s}'.format(format_decimal(data['count'])) }}
{%- endmacro %}

{% macro protocols(data) -%}
{% if data['source']['proto'] or data['target']['proto'] %}{{ ', '.join((data['source']['proto'] + data['target']['proto']) | unique | sort) }}{% else %}---{% endif %}
{%- endmacro %}

{% macro format_number(number, width, empty_value='---') -%}
{% if number %}{{ ('{:>' + (width|string) + 's}').format(format_decimal(number)) }}{% else %}{{ ('{:>' + (width|string) + 's}').format(empty_value) }}{% endif %}
{%- endmacro %}

{% macro row(key, data, additional_vars) -%}
{{ row_start(key, data, additional_vars) }}  {{ protocols(data) }}
{%- endmacro %}